#pragma once

// Ugly macro exapnsion to handle which ufunc
// TODO: the ufunc callback needs to use enums
#define DEF_BINARY_USTUB(_FUNC_, _ATYPE_) void F##_ATYPE_##_FUNC_(char **args, const npy_intp *dimensions, const npy_intp *steps, void*innerloop) { \
    return AtopBinaryMathFunction(args, dimensions, steps, innerloop, _FUNC_, _ATYPE_);}

#define DEF_BINARY_USTUB_EXPAND(_FUNC_) \
    DEF_BINARY_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_INT8); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_INT16); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_INT32); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_INT64); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_INT128); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_BINARY_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_BINARY_USTUB_EXPAND(0)
DEF_BINARY_USTUB_EXPAND(1)
DEF_BINARY_USTUB_EXPAND(2)
DEF_BINARY_USTUB_EXPAND(3)
DEF_BINARY_USTUB_EXPAND(4)
DEF_BINARY_USTUB_EXPAND(5)
DEF_BINARY_USTUB_EXPAND(6)
DEF_BINARY_USTUB_EXPAND(7)
DEF_BINARY_USTUB_EXPAND(8)
DEF_BINARY_USTUB_EXPAND(9)
DEF_BINARY_USTUB_EXPAND(10)
DEF_BINARY_USTUB_EXPAND(11)
DEF_BINARY_USTUB_EXPAND(12)
DEF_BINARY_USTUB_EXPAND(13)
DEF_BINARY_USTUB_EXPAND(14)
DEF_BINARY_USTUB_EXPAND(15)
DEF_BINARY_USTUB_EXPAND(16)
DEF_BINARY_USTUB_EXPAND(17)
DEF_BINARY_USTUB_EXPAND(18)
DEF_BINARY_USTUB_EXPAND(19)
DEF_BINARY_USTUB_EXPAND(20)
DEF_BINARY_USTUB_EXPAND(21)
DEF_BINARY_USTUB_EXPAND(22)
DEF_BINARY_USTUB_EXPAND(23)
DEF_BINARY_USTUB_EXPAND(24)
DEF_BINARY_USTUB_EXPAND(25)
DEF_BINARY_USTUB_EXPAND(26)

#define DEF_BINARY_USTUB_NAME(_FUNC_) \
    FATOP_BOOL##_FUNC_, \
    FATOP_INT8##_FUNC_, \
    FATOP_UINT8##_FUNC_, \
    FATOP_INT16##_FUNC_, \
    FATOP_UINT16##_FUNC_, \
    FATOP_INT32##_FUNC_, \
    FATOP_UINT32##_FUNC_, \
    FATOP_INT64##_FUNC_, \
    FATOP_UINT64##_FUNC_, \
    FATOP_INT128##_FUNC_, \
    FATOP_UINT128##_FUNC_, \
    FATOP_HALF_FLOAT##_FUNC_, \
    FATOP_FLOAT##_FUNC_, \
    FATOP_DOUBLE##_FUNC_, \
    FATOP_LONGDOUBLE##_FUNC_, \
    FATOP_CHALF_FLOAT##_FUNC_, \
    FATOP_CFLOAT##_FUNC_, \
    FATOP_CDOUBLE##_FUNC_, \
    FATOP_CLONGDOUBLE##_FUNC_ 

PyUFuncGenericFunction g_UFuncGenericLUT[BINARY_OPERATION::BINARY_LAST][ATOP_LAST] =
{
{DEF_BINARY_USTUB_NAME(0)},
{DEF_BINARY_USTUB_NAME(1)},
{DEF_BINARY_USTUB_NAME(2)},
{DEF_BINARY_USTUB_NAME(3)},
{DEF_BINARY_USTUB_NAME(4)},
{DEF_BINARY_USTUB_NAME(5)},
{DEF_BINARY_USTUB_NAME(6)},
{DEF_BINARY_USTUB_NAME(7)},
{DEF_BINARY_USTUB_NAME(8)},
{DEF_BINARY_USTUB_NAME(9)},
{DEF_BINARY_USTUB_NAME(10)},
{DEF_BINARY_USTUB_NAME(11)},
{DEF_BINARY_USTUB_NAME(12)},
{DEF_BINARY_USTUB_NAME(13)},
{DEF_BINARY_USTUB_NAME(14)},
{DEF_BINARY_USTUB_NAME(15)},
{DEF_BINARY_USTUB_NAME(16)},
{DEF_BINARY_USTUB_NAME(17)},
{DEF_BINARY_USTUB_NAME(18)},
{DEF_BINARY_USTUB_NAME(19)},
{DEF_BINARY_USTUB_NAME(20)},
{DEF_BINARY_USTUB_NAME(21)},
{DEF_BINARY_USTUB_NAME(22)},
{DEF_BINARY_USTUB_NAME(23)},
{DEF_BINARY_USTUB_NAME(24)},
{DEF_BINARY_USTUB_NAME(25)},
{DEF_BINARY_USTUB_NAME(26)},
};


#define DEF_COMP_USTUB(_FUNC_, _ATYPE_) void COMPF##_ATYPE_##_FUNC_(char **args, const npy_intp *dimensions, const npy_intp *steps, void*innerloop) { \
    return AtopCompareMathFunction(args, dimensions, steps, innerloop, _FUNC_, _ATYPE_);}

#define DEF_COMP_USTUB_EXPAND(_FUNC_) \
    DEF_COMP_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_COMP_USTUB(_FUNC_, ATOP_INT8); \
    DEF_COMP_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_COMP_USTUB(_FUNC_, ATOP_INT16); \
    DEF_COMP_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_COMP_USTUB(_FUNC_, ATOP_INT32); \
    DEF_COMP_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_COMP_USTUB(_FUNC_, ATOP_INT64); \
    DEF_COMP_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_COMP_USTUB(_FUNC_, ATOP_INT128); \
    DEF_COMP_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_COMP_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_COMP_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_COMP_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_COMP_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_COMP_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_COMP_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_COMP_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_COMP_USTUB(_FUNC_, ATOP_CLONGDOUBLE); 

// For however many functions there are
DEF_COMP_USTUB_EXPAND(0)
DEF_COMP_USTUB_EXPAND(1)
DEF_COMP_USTUB_EXPAND(2)
DEF_COMP_USTUB_EXPAND(3)
DEF_COMP_USTUB_EXPAND(4)
DEF_COMP_USTUB_EXPAND(5)

#define DEF_COMP_USTUB_NAME(_FUNC_) \
    COMPFATOP_BOOL##_FUNC_, \
    COMPFATOP_INT8##_FUNC_, \
    COMPFATOP_UINT8##_FUNC_, \
    COMPFATOP_INT16##_FUNC_, \
    COMPFATOP_UINT16##_FUNC_, \
    COMPFATOP_INT32##_FUNC_, \
    COMPFATOP_UINT32##_FUNC_, \
    COMPFATOP_INT64##_FUNC_, \
    COMPFATOP_UINT64##_FUNC_, \
    COMPFATOP_INT128##_FUNC_, \
    COMPFATOP_UINT128##_FUNC_, \
    COMPFATOP_HALF_FLOAT##_FUNC_, \
    COMPFATOP_FLOAT##_FUNC_, \
    COMPFATOP_DOUBLE##_FUNC_, \
    COMPFATOP_LONGDOUBLE##_FUNC_, \
    COMPFATOP_CHALF_FLOAT##_FUNC_, \
    COMPFATOP_CFLOAT##_FUNC_, \
    COMPFATOP_CDOUBLE##_FUNC_, \
    COMPFATOP_CLONGDOUBLE##_FUNC_ 

PyUFuncGenericFunction g_UFuncCompareLUT[COMP_OPERATION::CMP_LAST][ATOP_LAST] =
{
{DEF_COMP_USTUB_NAME(0)},
{DEF_COMP_USTUB_NAME(1)},
{DEF_COMP_USTUB_NAME(2)},
{DEF_COMP_USTUB_NAME(3)},
{DEF_COMP_USTUB_NAME(4)},
{DEF_COMP_USTUB_NAME(5)} };



#define DEF_UNARY_USTUB(_FUNC_, _ATYPE_) void UNARYF##_ATYPE_##_FUNC_(char **args, const npy_intp *dimensions, const npy_intp *steps, void*innerloop) { \
    return AtopUnaryMathFunction(args, dimensions, steps, innerloop, _FUNC_, _ATYPE_);}

#define DEF_UNARY_USTUB_EXPAND(_FUNC_) \
    DEF_UNARY_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_INT8); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_INT16); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_INT32); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_INT64); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_INT128); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_UNARY_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_UNARY_USTUB_EXPAND(0)
DEF_UNARY_USTUB_EXPAND(1)
DEF_UNARY_USTUB_EXPAND(2)
DEF_UNARY_USTUB_EXPAND(3)
DEF_UNARY_USTUB_EXPAND(4)
DEF_UNARY_USTUB_EXPAND(5)
DEF_UNARY_USTUB_EXPAND(6)
DEF_UNARY_USTUB_EXPAND(7)
DEF_UNARY_USTUB_EXPAND(8)
DEF_UNARY_USTUB_EXPAND(9)
DEF_UNARY_USTUB_EXPAND(10)
DEF_UNARY_USTUB_EXPAND(11)
DEF_UNARY_USTUB_EXPAND(12)
DEF_UNARY_USTUB_EXPAND(13)
DEF_UNARY_USTUB_EXPAND(14)
DEF_UNARY_USTUB_EXPAND(15)
DEF_UNARY_USTUB_EXPAND(16)
DEF_UNARY_USTUB_EXPAND(17)
DEF_UNARY_USTUB_EXPAND(18)
DEF_UNARY_USTUB_EXPAND(19)
DEF_UNARY_USTUB_EXPAND(20)
DEF_UNARY_USTUB_EXPAND(21)
DEF_UNARY_USTUB_EXPAND(22)
DEF_UNARY_USTUB_EXPAND(23)
DEF_UNARY_USTUB_EXPAND(24)
DEF_UNARY_USTUB_EXPAND(25)
DEF_UNARY_USTUB_EXPAND(26)
DEF_UNARY_USTUB_EXPAND(27)
DEF_UNARY_USTUB_EXPAND(28)
DEF_UNARY_USTUB_EXPAND(29)

#define DEF_UNARY_USTUB_NAME(_FUNC_) \
    UNARYFATOP_BOOL##_FUNC_, \
    UNARYFATOP_INT8##_FUNC_, \
    UNARYFATOP_UINT8##_FUNC_, \
    UNARYFATOP_INT16##_FUNC_, \
    UNARYFATOP_UINT16##_FUNC_, \
    UNARYFATOP_INT32##_FUNC_, \
    UNARYFATOP_UINT32##_FUNC_, \
    UNARYFATOP_INT64##_FUNC_, \
    UNARYFATOP_UINT64##_FUNC_, \
    UNARYFATOP_INT128##_FUNC_, \
    UNARYFATOP_UINT128##_FUNC_, \
    UNARYFATOP_HALF_FLOAT##_FUNC_, \
    UNARYFATOP_FLOAT##_FUNC_, \
    UNARYFATOP_DOUBLE##_FUNC_, \
    UNARYFATOP_LONGDOUBLE##_FUNC_, \
    UNARYFATOP_CHALF_FLOAT##_FUNC_, \
    UNARYFATOP_CFLOAT##_FUNC_, \
    UNARYFATOP_CDOUBLE##_FUNC_, \
    UNARYFATOP_CLONGDOUBLE##_FUNC_ 

PyUFuncGenericFunction g_UFuncUnaryLUT[UNARY_OPERATION::UNARY_LAST][ATOP_LAST] =
{
{DEF_UNARY_USTUB_NAME(0)},
{DEF_UNARY_USTUB_NAME(1)},
{DEF_UNARY_USTUB_NAME(2)},
{DEF_UNARY_USTUB_NAME(3)},
{DEF_UNARY_USTUB_NAME(4)},
{DEF_UNARY_USTUB_NAME(5)},
{DEF_UNARY_USTUB_NAME(6)},
{DEF_UNARY_USTUB_NAME(7)},
{DEF_UNARY_USTUB_NAME(8)},
{DEF_UNARY_USTUB_NAME(9)},
{DEF_UNARY_USTUB_NAME(10)},
{DEF_UNARY_USTUB_NAME(11)},
{DEF_UNARY_USTUB_NAME(12)},
{DEF_UNARY_USTUB_NAME(13)},
{DEF_UNARY_USTUB_NAME(14)},
{DEF_UNARY_USTUB_NAME(15)},
{DEF_UNARY_USTUB_NAME(16)},
{DEF_UNARY_USTUB_NAME(17)},
{DEF_UNARY_USTUB_NAME(18)},
{DEF_UNARY_USTUB_NAME(19)},
{DEF_UNARY_USTUB_NAME(20)},
{DEF_UNARY_USTUB_NAME(21)},
{DEF_UNARY_USTUB_NAME(22)},
{DEF_UNARY_USTUB_NAME(23)},
{DEF_UNARY_USTUB_NAME(24)},
{DEF_UNARY_USTUB_NAME(25)},
{DEF_UNARY_USTUB_NAME(26)},
{DEF_UNARY_USTUB_NAME(27)},
{DEF_UNARY_USTUB_NAME(28)},
{DEF_UNARY_USTUB_NAME(29)},
};



//=============================================================================
// Trig

#define DEF_TRIG_USTUB(_FUNC_, _ATYPE_) void TRIGF##_ATYPE_##_FUNC_(char **args, const npy_intp *dimensions, const npy_intp *steps, void*innerloop) { \
    return AtopTrigMathFunction(args, dimensions, steps, innerloop, _FUNC_, _ATYPE_);}

#define DEF_TRIG_USTUB_EXPAND(_FUNC_) \
    DEF_TRIG_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_INT8); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_INT16); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_INT32); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_INT64); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_INT128); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_TRIG_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_TRIG_USTUB_EXPAND(0)
DEF_TRIG_USTUB_EXPAND(1)
DEF_TRIG_USTUB_EXPAND(2)
DEF_TRIG_USTUB_EXPAND(3)
DEF_TRIG_USTUB_EXPAND(4)
DEF_TRIG_USTUB_EXPAND(5)
DEF_TRIG_USTUB_EXPAND(6)
DEF_TRIG_USTUB_EXPAND(7)
DEF_TRIG_USTUB_EXPAND(8)
DEF_TRIG_USTUB_EXPAND(9)
DEF_TRIG_USTUB_EXPAND(10)
DEF_TRIG_USTUB_EXPAND(11)
DEF_TRIG_USTUB_EXPAND(12)
DEF_TRIG_USTUB_EXPAND(13)
DEF_TRIG_USTUB_EXPAND(14)
DEF_TRIG_USTUB_EXPAND(15)
DEF_TRIG_USTUB_EXPAND(16)
DEF_TRIG_USTUB_EXPAND(17)
DEF_TRIG_USTUB_EXPAND(18)
DEF_TRIG_USTUB_EXPAND(19)
DEF_TRIG_USTUB_EXPAND(20)
DEF_TRIG_USTUB_EXPAND(21)
DEF_TRIG_USTUB_EXPAND(22)
DEF_TRIG_USTUB_EXPAND(23)
DEF_TRIG_USTUB_EXPAND(24)
DEF_TRIG_USTUB_EXPAND(25)
DEF_TRIG_USTUB_EXPAND(26)
DEF_TRIG_USTUB_EXPAND(27)
DEF_TRIG_USTUB_EXPAND(28)
DEF_TRIG_USTUB_EXPAND(29)

#define DEF_TRIG_USTUB_NAME(_FUNC_) \
    TRIGFATOP_BOOL##_FUNC_, \
    TRIGFATOP_INT8##_FUNC_, \
    TRIGFATOP_UINT8##_FUNC_, \
    TRIGFATOP_INT16##_FUNC_, \
    TRIGFATOP_UINT16##_FUNC_, \
    TRIGFATOP_INT32##_FUNC_, \
    TRIGFATOP_UINT32##_FUNC_, \
    TRIGFATOP_INT64##_FUNC_, \
    TRIGFATOP_UINT64##_FUNC_, \
    TRIGFATOP_INT128##_FUNC_, \
    TRIGFATOP_UINT128##_FUNC_, \
    TRIGFATOP_HALF_FLOAT##_FUNC_, \
    TRIGFATOP_FLOAT##_FUNC_, \
    TRIGFATOP_DOUBLE##_FUNC_, \
    TRIGFATOP_LONGDOUBLE##_FUNC_, \
    TRIGFATOP_CHALF_FLOAT##_FUNC_, \
    TRIGFATOP_CFLOAT##_FUNC_, \
    TRIGFATOP_CDOUBLE##_FUNC_, \
    TRIGFATOP_CLONGDOUBLE##_FUNC_ 

PyUFuncGenericFunction g_UFuncTrigLUT[TRIG_OPERATION::TRIG_LAST][ATOP_LAST] =
{
{DEF_TRIG_USTUB_NAME(0)},
{DEF_TRIG_USTUB_NAME(1)},
{DEF_TRIG_USTUB_NAME(2)},
{DEF_TRIG_USTUB_NAME(3)},
{DEF_TRIG_USTUB_NAME(4)},
{DEF_TRIG_USTUB_NAME(5)},
{DEF_TRIG_USTUB_NAME(6)},
{DEF_TRIG_USTUB_NAME(7)},
{DEF_TRIG_USTUB_NAME(8)},
{DEF_TRIG_USTUB_NAME(9)},
{DEF_TRIG_USTUB_NAME(10)},
{DEF_TRIG_USTUB_NAME(11)},
{DEF_TRIG_USTUB_NAME(12)},
{DEF_TRIG_USTUB_NAME(13)},
{DEF_TRIG_USTUB_NAME(14)},
{DEF_TRIG_USTUB_NAME(15)},
{DEF_TRIG_USTUB_NAME(16)},
{DEF_TRIG_USTUB_NAME(17)},
{DEF_TRIG_USTUB_NAME(18)},
{DEF_TRIG_USTUB_NAME(19)},
{DEF_TRIG_USTUB_NAME(20)},
};


//=============================================================================
// Sort
//static void AtopConvertFunction(char* pDest, char* pSrc, npy_intp length, PyArrayObject* fromarr, PyArrayObject* toarr, int fromtype, int totype) {
// call the central convesion routine
#define DEF_CONVERT_USTUB(_FUNC_, _ATYPE_) void CONVERTF##_ATYPE_##_FUNC_(void* pDest, void* pSrc, npy_intp length, void* fromarr, void* toarr) { \
    return AtopConvertMathFunction(pDest, pSrc, length, fromarr, toarr, _FUNC_, _ATYPE_);}

#define DEF_CONVERT_USTUB_EXPAND(_FUNC_) \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_INT8); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_INT16); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_INT32); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_INT64); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_INT128); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_CONVERT_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_CONVERT_USTUB_EXPAND(0)
DEF_CONVERT_USTUB_EXPAND(1)
DEF_CONVERT_USTUB_EXPAND(2)
DEF_CONVERT_USTUB_EXPAND(3)
DEF_CONVERT_USTUB_EXPAND(4)
DEF_CONVERT_USTUB_EXPAND(5)
DEF_CONVERT_USTUB_EXPAND(6)
DEF_CONVERT_USTUB_EXPAND(7)
DEF_CONVERT_USTUB_EXPAND(8)
DEF_CONVERT_USTUB_EXPAND(9)
DEF_CONVERT_USTUB_EXPAND(10)
DEF_CONVERT_USTUB_EXPAND(11)
DEF_CONVERT_USTUB_EXPAND(12)
DEF_CONVERT_USTUB_EXPAND(13)
DEF_CONVERT_USTUB_EXPAND(14)
DEF_CONVERT_USTUB_EXPAND(15)
DEF_CONVERT_USTUB_EXPAND(16)
DEF_CONVERT_USTUB_EXPAND(17)
DEF_CONVERT_USTUB_EXPAND(18)
DEF_CONVERT_USTUB_EXPAND(19)
DEF_CONVERT_USTUB_EXPAND(20)
DEF_CONVERT_USTUB_EXPAND(21)

#define DEF_CONVERT_USTUB_NAME(_FUNC_) \
    CONVERTFATOP_BOOL##_FUNC_, \
    CONVERTFATOP_INT8##_FUNC_, \
    CONVERTFATOP_UINT8##_FUNC_, \
    CONVERTFATOP_INT16##_FUNC_, \
    CONVERTFATOP_UINT16##_FUNC_, \
    CONVERTFATOP_INT32##_FUNC_, \
    CONVERTFATOP_UINT32##_FUNC_, \
    CONVERTFATOP_INT64##_FUNC_, \
    CONVERTFATOP_UINT64##_FUNC_, \
    CONVERTFATOP_INT128##_FUNC_, \
    CONVERTFATOP_UINT128##_FUNC_, \
    CONVERTFATOP_HALF_FLOAT##_FUNC_, \
    CONVERTFATOP_FLOAT##_FUNC_, \
    CONVERTFATOP_DOUBLE##_FUNC_, \
    CONVERTFATOP_LONGDOUBLE##_FUNC_, \
    CONVERTFATOP_CHALF_FLOAT##_FUNC_, \
    CONVERTFATOP_CFLOAT##_FUNC_, \
    CONVERTFATOP_CDOUBLE##_FUNC_, \
    CONVERTFATOP_CLONGDOUBLE##_FUNC_ 


// Not currently used
PyVFuncGenericFunction g_UFuncConvertLUT[ATOP_LAST][ATOP_LAST] =
{
{DEF_CONVERT_USTUB_NAME(0)},
{DEF_CONVERT_USTUB_NAME(1)},
{DEF_CONVERT_USTUB_NAME(2)},
{DEF_CONVERT_USTUB_NAME(3)},
{DEF_CONVERT_USTUB_NAME(4)},
{DEF_CONVERT_USTUB_NAME(5)},
{DEF_CONVERT_USTUB_NAME(6)},
{DEF_CONVERT_USTUB_NAME(7)},
{DEF_CONVERT_USTUB_NAME(8)},
{DEF_CONVERT_USTUB_NAME(9)},
{DEF_CONVERT_USTUB_NAME(10)},
{DEF_CONVERT_USTUB_NAME(11)},
{DEF_CONVERT_USTUB_NAME(12)},
{DEF_CONVERT_USTUB_NAME(13)},
{DEF_CONVERT_USTUB_NAME(14)},
{DEF_CONVERT_USTUB_NAME(15)},
{DEF_CONVERT_USTUB_NAME(16)},
{DEF_CONVERT_USTUB_NAME(17)},
{DEF_CONVERT_USTUB_NAME(18)},
{DEF_CONVERT_USTUB_NAME(19)},
{DEF_CONVERT_USTUB_NAME(20)},
{DEF_CONVERT_USTUB_NAME(21)},
};

//=============================================================================
// Sort
#define DEF_SORT_USTUB(_FUNC_, _ATYPE_) int SORTF##_ATYPE_##_FUNC_(void* pDest, npy_intp length, void* pSrc) { \
    return AtopSortMathFunction(pDest, length, pSrc, _FUNC_, _ATYPE_);}

#define DEF_SORT_USTUB_EXPAND(_FUNC_) \
    DEF_SORT_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_SORT_USTUB(_FUNC_, ATOP_INT8); \
    DEF_SORT_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_SORT_USTUB(_FUNC_, ATOP_INT16); \
    DEF_SORT_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_SORT_USTUB(_FUNC_, ATOP_INT32); \
    DEF_SORT_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_SORT_USTUB(_FUNC_, ATOP_INT64); \
    DEF_SORT_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_SORT_USTUB(_FUNC_, ATOP_INT128); \
    DEF_SORT_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_SORT_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_SORT_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_SORT_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_SORT_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_SORT_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_SORT_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_SORT_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_SORT_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_SORT_USTUB_EXPAND(0)
DEF_SORT_USTUB_EXPAND(1)
DEF_SORT_USTUB_EXPAND(2)

#define DEF_SORT_USTUB_NAME(_FUNC_) \
    SORTFATOP_BOOL##_FUNC_, \
    SORTFATOP_INT8##_FUNC_, \
    SORTFATOP_UINT8##_FUNC_, \
    SORTFATOP_INT16##_FUNC_, \
    SORTFATOP_UINT16##_FUNC_, \
    SORTFATOP_INT32##_FUNC_, \
    SORTFATOP_UINT32##_FUNC_, \
    SORTFATOP_INT64##_FUNC_, \
    SORTFATOP_UINT64##_FUNC_, \
    SORTFATOP_INT128##_FUNC_, \
    SORTFATOP_UINT128##_FUNC_, \
    SORTFATOP_HALF_FLOAT##_FUNC_, \
    SORTFATOP_FLOAT##_FUNC_, \
    SORTFATOP_DOUBLE##_FUNC_, \
    SORTFATOP_LONGDOUBLE##_FUNC_, \
    SORTFATOP_CHALF_FLOAT##_FUNC_, \
    SORTFATOP_CFLOAT##_FUNC_, \
    SORTFATOP_CDOUBLE##_FUNC_, \
    SORTFATOP_CLONGDOUBLE##_FUNC_ 


SortFunc g_UFuncSortLUT[NPY_NSORTS][ATOP_LAST] =
{
{DEF_SORT_USTUB_NAME(0)},
{DEF_SORT_USTUB_NAME(1)},
{DEF_SORT_USTUB_NAME(2)},
};


//=============================================================================
// ArgSort
#define DEF_ARGSORT_USTUB(_FUNC_, _ATYPE_) int ARGSORTF##_ATYPE_##_FUNC_(void* pDest, npy_intp* something, npy_intp length, void* pSrc) { \
    return AtopArgSortMathFunction(pDest, something, length, pSrc, _FUNC_, _ATYPE_);}

#define DEF_ARGSORT_USTUB_EXPAND(_FUNC_) \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_INT8); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_INT16); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_INT32); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_INT64); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_INT128); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_ARGSORT_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_ARGSORT_USTUB_EXPAND(0)
DEF_ARGSORT_USTUB_EXPAND(1)
DEF_ARGSORT_USTUB_EXPAND(2)

#define DEF_ARGSORT_USTUB_NAME(_FUNC_) \
    ARGSORTFATOP_BOOL##_FUNC_, \
    ARGSORTFATOP_INT8##_FUNC_, \
    ARGSORTFATOP_UINT8##_FUNC_, \
    ARGSORTFATOP_INT16##_FUNC_, \
    ARGSORTFATOP_UINT16##_FUNC_, \
    ARGSORTFATOP_INT32##_FUNC_, \
    ARGSORTFATOP_UINT32##_FUNC_, \
    ARGSORTFATOP_INT64##_FUNC_, \
    ARGSORTFATOP_UINT64##_FUNC_, \
    ARGSORTFATOP_INT128##_FUNC_, \
    ARGSORTFATOP_UINT128##_FUNC_, \
    ARGSORTFATOP_HALF_FLOAT##_FUNC_, \
    ARGSORTFATOP_FLOAT##_FUNC_, \
    ARGSORTFATOP_DOUBLE##_FUNC_, \
    ARGSORTFATOP_LONGDOUBLE##_FUNC_, \
    ARGSORTFATOP_CHALF_FLOAT##_FUNC_, \
    ARGSORTFATOP_CFLOAT##_FUNC_, \
    ARGSORTFATOP_CDOUBLE##_FUNC_, \
    ARGSORTFATOP_CLONGDOUBLE##_FUNC_ 


ArgSortFunc g_UFuncArgSortLUT[NPY_NSORTS][ATOP_LAST] =
{
{DEF_ARGSORT_USTUB_NAME(0)},
{DEF_ARGSORT_USTUB_NAME(1)},
{DEF_ARGSORT_USTUB_NAME(2)},
};


//=============================================================================
// ArgMinMax
#define DEF_ARGMINMAX_USTUB(_FUNC_, _ATYPE_) int ARGMINMAXF##_ATYPE_##_FUNC_(void* pDest, npy_intp length, npy_intp* something,  void* pSrc) { \
    return AtopArgMinMaxMathFunction(pDest, length, something, pSrc, _FUNC_, _ATYPE_);}

#define DEF_ARGMINMAX_USTUB_EXPAND(_FUNC_) \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_BOOL); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_INT8); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_UINT8); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_INT16); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_UINT16); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_INT32); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_UINT32); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_INT64); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_UINT64); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_INT128); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_UINT128); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_HALF_FLOAT); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_FLOAT); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_DOUBLE); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_LONGDOUBLE); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_CHALF_FLOAT); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_CFLOAT); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_CDOUBLE); \
    DEF_ARGMINMAX_USTUB(_FUNC_, ATOP_CLONGDOUBLE);

// For however many functions there are
DEF_ARGMINMAX_USTUB_EXPAND(0)
DEF_ARGMINMAX_USTUB_EXPAND(1)

#define DEF_ARGMINMAX_USTUB_NAME(_FUNC_) \
    ARGMINMAXFATOP_BOOL##_FUNC_, \
    ARGMINMAXFATOP_INT8##_FUNC_, \
    ARGMINMAXFATOP_UINT8##_FUNC_, \
    ARGMINMAXFATOP_INT16##_FUNC_, \
    ARGMINMAXFATOP_UINT16##_FUNC_, \
    ARGMINMAXFATOP_INT32##_FUNC_, \
    ARGMINMAXFATOP_UINT32##_FUNC_, \
    ARGMINMAXFATOP_INT64##_FUNC_, \
    ARGMINMAXFATOP_UINT64##_FUNC_, \
    ARGMINMAXFATOP_INT128##_FUNC_, \
    ARGMINMAXFATOP_UINT128##_FUNC_, \
    ARGMINMAXFATOP_HALF_FLOAT##_FUNC_, \
    ARGMINMAXFATOP_FLOAT##_FUNC_, \
    ARGMINMAXFATOP_DOUBLE##_FUNC_, \
    ARGMINMAXFATOP_LONGDOUBLE##_FUNC_, \
    ARGMINMAXFATOP_CHALF_FLOAT##_FUNC_, \
    ARGMINMAXFATOP_CFLOAT##_FUNC_, \
    ARGMINMAXFATOP_CDOUBLE##_FUNC_, \
    ARGMINMAXFATOP_CLONGDOUBLE##_FUNC_ 


ArgMinMaxFunc g_UFuncArgMinMaxLUT[2][ATOP_LAST] =
{
{DEF_ARGMINMAX_USTUB_NAME(0)},
{DEF_ARGMINMAX_USTUB_NAME(1)},
};


//=============================================================================
// Arange
#define DEF_ARANGE_USTUB(_ATYPE_) int ARANGEF##_ATYPE_(void* pDest, npy_intp length, void* unused) { \
    return AtopArangeMathFunction(pDest, length, unused, _ATYPE_);}

DEF_ARANGE_USTUB(ATOP_BOOL); 
DEF_ARANGE_USTUB(ATOP_INT8); 
DEF_ARANGE_USTUB(ATOP_UINT8); 
DEF_ARANGE_USTUB(ATOP_INT16); 
DEF_ARANGE_USTUB(ATOP_UINT16); 
DEF_ARANGE_USTUB(ATOP_INT32); 
DEF_ARANGE_USTUB(ATOP_UINT32); 
DEF_ARANGE_USTUB(ATOP_INT64); 
DEF_ARANGE_USTUB(ATOP_UINT64); 
DEF_ARANGE_USTUB(ATOP_INT128); 
DEF_ARANGE_USTUB(ATOP_UINT128); 
DEF_ARANGE_USTUB(ATOP_HALF_FLOAT); 
DEF_ARANGE_USTUB(ATOP_FLOAT); 
DEF_ARANGE_USTUB(ATOP_DOUBLE); 
DEF_ARANGE_USTUB(ATOP_LONGDOUBLE); 
DEF_ARANGE_USTUB(ATOP_CHALF_FLOAT); 
DEF_ARANGE_USTUB(ATOP_CFLOAT); 
DEF_ARANGE_USTUB(ATOP_CDOUBLE); 
DEF_ARANGE_USTUB(ATOP_CLONGDOUBLE);


ArangeFunc g_UFuncArangeLUT[ATOP_LAST] =

{   ARANGEFATOP_BOOL, 
    ARANGEFATOP_INT8, 
    ARANGEFATOP_UINT8, 
    ARANGEFATOP_INT16, 
    ARANGEFATOP_UINT16, 
    ARANGEFATOP_INT32, 
    ARANGEFATOP_UINT32, 
    ARANGEFATOP_INT64, 
    ARANGEFATOP_UINT64, 
    ARANGEFATOP_INT128, 
    ARANGEFATOP_UINT128, 
    ARANGEFATOP_HALF_FLOAT, 
    ARANGEFATOP_FLOAT, 
    ARANGEFATOP_DOUBLE, 
    ARANGEFATOP_LONGDOUBLE, 
    ARANGEFATOP_CHALF_FLOAT, 
    ARANGEFATOP_CFLOAT, 
    ARANGEFATOP_CDOUBLE, 
    ARANGEFATOP_CLONGDOUBLE 
};

